// PSampleView.cpp : implementation of the CPSampleView class
//

#include "stdafx.h"
#include "PSample.h"

#include "PSampleDoc.h"
#include "PSampleView.h"
#include "PrivacyDialog.h"
#include "ReportDialog.h"
#include "PrivacyDisclosure.h"

#include "WinInet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPSampleView
IMPLEMENT_DYNCREATE(CPSampleView, CView)

BEGIN_MESSAGE_MAP(CPSampleView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_COMMAND(ID_HELP_PRIVACYSTATEMENT, OnHelpPrivacystatement)
	ON_COMMAND(ID_TOOLS_OPTIONS, OnToolsOptions)
	ON_COMMAND(ID_HELP_PRIVACYREPORT, OnHelpPrivacyreport)
END_MESSAGE_MAP()

// CPSampleView construction/destruction

CPSampleView::CPSampleView()
{
	// TODO: add construction code here

}

CPSampleView::~CPSampleView()
{
}

BOOL CPSampleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CPSampleView drawing

void CPSampleView::OnDraw(CDC* /*pDC*/)
{
	CPSampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CPSampleView printing

BOOL CPSampleView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPSampleView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPSampleView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CPSampleView diagnostics

#ifdef _DEBUG
void CPSampleView::AssertValid() const
{
	CView::AssertValid();
}

void CPSampleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPSampleDoc* CPSampleView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPSampleDoc)));
	return (CPSampleDoc*)m_pDocument;
}
#endif //_DEBUG


// CPSampleView message handlers


// ---------------------------------------------------------------------------
// Initialize the key if it has not been created
// ---------------------------------------------------------------------------
void CPSampleView::OnInitialUpdate()
{
	DWORD	dwZero = 0;
	HKEY	hKey;
	long	lRes;

	// Retrieve the policy information from the registry
	lRes = RegOpenKey(HKEY_CURRENT_USER, PREFERENCE_KEY, &hKey);

	if (! (ERROR_SUCCESS == lRes))  // Was the registry key defined?
    {
		// No, create the key and initialize the privacy values

		DWORD dwDisp; // The disposition of the CreateKey call

		lRes = RegCreateKeyEx(HKEY_CURRENT_USER, PREFERENCE_KEY, 0, "", 0, 
                              KEY_READ | KEY_WRITE, NULL, &hKey, &dwDisp); 

		if (ERROR_SUCCESS == lRes)  // Was the registry key created?
		{
			CPrivacyDialog PrivacyDialog;

			// Yes, initalize the preference settings
			RegSetValueEx(hKey, ONLINE_HELP, 0, REG_DWORD, (LPBYTE)&dwZero,
						  sizeof(DWORD));
			RegSetValueEx(hKey, ONLINE_SEARCH, 0, REG_DWORD, (LPBYTE)&dwZero,
						  sizeof(DWORD));
			dwZero = 1;  // Enable automatic updates
			RegSetValueEx(hKey, AUTO_UPDATE, 0, REG_DWORD, (LPBYTE)&dwZero,
						  sizeof(DWORD));
			RegCloseKey(hKey);      

			// Give the user the opportunity to change the settings.
			PrivacyDialog.DoModal();
		}
	}
} // OnInitialUpdate

// ---------------------------------------------------------------------------
// Display the privacy statement for the application in the browser. The
// privacy statement is assumed to be in the root of the web server where
// the program is being run in the file "PrivacyStatement.html".
// ---------------------------------------------------------------------------
void CPSampleView::OnHelpPrivacystatement()
{
	BOOL bConnected;

	// See if the computer is connected to Internet
	bConnected = InternetCheckConnection("http://www.ietf.org/", FLAG_ICC_FORCE_CONNECTION, 0);

	// If connected to the Internet display the online privacy statement
	if (bConnected)
	{
		PROCESS_INFORMATION	pi;
		STARTUPINFO			si;

		ZeroMemory(&pi, sizeof(pi));
		ZeroMemory(&si, sizeof(si));
		si.cb = sizeof(si);

		if(CreateProcess(NULL, // No module name (use command line). 
			       "Explorer http://localhost/Privacy/PrivacyStatement.html",
			        NULL,          // Process handle not inheritable. 
			        NULL,          // Thread handle not inheritable. 
			        FALSE,         // Set handle inheritance to FALSE. 
			        0,             // No creation flags. 
			        NULL,          // Use parent's environment block. 
			        NULL,          // Use parent's starting directory. 
			        &si,           // Pointer to STARTUPINFO structure.
			        &pi)           // Pointer to PROCESS_INFORMATION structure.
		) 
		{
			// Close process and thread handles. 
			CloseHandle( pi.hProcess );
			CloseHandle( pi.hThread );
		}
		else // Display an error message
		{
			MessageBox("Call to CreateProcess failed.");
		}
	}
	else // Display the local disclosure statement
	{
		CPrivacyDisclosure PrivacyDisclosure;

		PrivacyDisclosure.DoModal();
	}

} // OnHelpPrivacystatement

// ---------------------------------------------------------------------------
// Display the privacy settings dialog.
// ---------------------------------------------------------------------------
void CPSampleView::OnToolsOptions()
{
	CPrivacyDialog PrivacyDialog;

	PrivacyDialog.DoModal();
} // OnToolsOptions

// ---------------------------------------------------------------------------
// Display the privacy report dialog.
// ---------------------------------------------------------------------------
void CPSampleView::OnHelpPrivacyreport()
{
	CReportDialog ReportDialog;

	ReportDialog.DoModal();
} // OnHelpPrivacyreport
