// Encrypt.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <windows.h>
#include <wincrypt.h>

void DisplayLastError(LPSTR szPreamble)
{
	LPVOID lpErrMsg;

	if (FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | 
					  FORMAT_MESSAGE_FROM_SYSTEM,
					  NULL,	GetLastError(),0,
		             (LPTSTR) &lpErrMsg, 0,	NULL ))
	{
		fputs(szPreamble, stdout);
		putch(':');
		puts((LPCSTR)lpErrMsg);  // Display the error
		LocalFree(lpErrMsg);     // Free the memory allocated for the buffer
	}
}
int _tmain(int argc, _TCHAR* argv[])
{
	HCRYPTHASH hHash;
	HCRYPTPROV hCryptProv;

	// Get the handle to the Digital Signature Standard provider. Use the
	// CRYPT_NEWKEYSET value as the last parameter to create the key container
	if (CryptAcquireContext(&hCryptProv, "PSample", MS_DEF_DSS_PROV, PROV_DSS, 0))
	{
		if (CryptCreateHash(hCryptProv, CALG_SHA, 0, 0, &hHash))
		{
			const BYTE * pHashData = (const BYTE *)"123-45-5678";

			BOOL	bResult;
			DWORD	dwBufferSize, dwValue;
			BYTE*	pBuffer;

			CryptHashData(hHash, pHashData, 11, 0);
			dwBufferSize = sizeof(DWORD);

			// Get the size of the hashed data
			bResult = CryptGetHashParam(hHash, HP_HASHSIZE, (BYTE*)&dwValue,
				                       &dwBufferSize, 0);
			dwBufferSize = dwValue;

			// Create a buffer to hold the hash value.
			pBuffer = (BYTE *)new char [dwBufferSize];

			// Get hash value.
			bResult = CryptGetHashParam(hHash, HP_HASHVAL, pBuffer, &dwBufferSize, 0);

			// Store the value in a database or other data store

			CryptDestroyHash(hHash); // Release hash object.
        } 
        else
        {
			DisplayLastError("Error occurred during CryptCreateHash()"); 
        }
		CryptReleaseContext(hCryptProv, 0);
	}
	else
	{
		DisplayLastError("Error occurred during CryptAcquireContext()"); 
	}
	return 0;
}

