<%@ Language=VBScript %>
<html>
	<head>
		<title>Patient Table</title>
		<meta name="GENERATOR" content="Microsoft Visual Studio .NET 7.1">
		<meta name="vs_targetSchema" content="http://schemas.microsoft.com/intellisense/ie5">
	</head>
	<body>
<!-- #include file = "Header.inc" -->
		<h1>Patient Table</h1>
		<table>
			<tr cellspacing=2 bgcolor=#999999  align=left>
				<th>PatientID
				<th>Name
				<th>Address
				<th>City
				<th>CC#
				<th>ExpDate
				<th>SSN
				<th>Blood

<!-- #include file = "Password.inc" -->

<% 
	Dim arrDecrypt(20)	' Define the decryption array
	DataCategory = Server.HTMLEncode(Session("DataCategory"))	

	' Connect to the DrOffice database
	Set oConn = CreateObject("adodb.connection")
	oConn.Open "DROfficeDB", "DBTest", Password
	
	' Get the value for the 'sensitive' data category	
	Set oRS = oConn.Execute("SELECT DataCategory FROM DataCategory WHERE Name = 'Sensitive'")
	nSensitive = oRS("DataCategory")

	' If the user has access to every column then set the select statement to retrieve
	' every column. Otherwise, build the select statement	
	If DataCategory = 0 Then
		SQLString = "Select *, "
	Else
		' Initialize the local variables to asterisks
		PatientID = "****"
		Name = "****"
		Address = "****"
		City = "****"
		CCN = "****"
		ExpDate = "****"
		SSN = "****"
		BloodType = "****"
		
		SQLString = "Select "
	End if	
	
	' Get the column names for the Patients table
	Set oRS = oConn.Execute("SELECT Top 0 * FROM Patients")
	Set Flds = oRS.Fields

	i = 1
	
	' Read the data category for each column in the Patients table and determine which
	' ones match the data access category for the current role.
	' Also determine if any of the fields require decryption.
	For Each fld In Flds
		Set oRS = oConn.Execute("SELECT CAST([value] AS varchar) AS [Value] FROM " &_
								"::FN_LISTEXTENDEDPROPERTY('DataCategory', 'User', " &_
								"'dbo','table', 'patients', 'column', '" & Fld.name & "')")
		
		' If the data category for the column matches the one for the role then add
		' it to the Select statement.	                
		' This If statement never gets processed when the DataAccess value is "All"      
		If oRS("Value") = DataCategory Then
			SQLString = SQLString + Fld.name + ", "
		End if
		
		' Ensure that encrypted columns get decrypted
		If CInt(oRS("Value")) = nSensitive Then
			arrDecrypt(i) = true
		Else
			arrDecrypt(i) = false
		End if
		
		i = i + 1
	Next
	
	' End the SQL string
	SQLString = SQLString + "NULL FROM Patients"
	
	Set oRS = oConn.Execute(SQLString)

	Set Flds = oRS.Fields

	' Process each returned row
	Do while NOT oRS.EOF
		' Copy the returned data into local variables. 
		' Decrypt the variable where necessary.
		For Each fld In Flds
			If Fld.Name = "PatientID" Then
				If arrDecrypt(1) = true then
					PatientID = DecryptString(oRS("PatientID"))
				Else
					PatientID = oRS("PatientID")
				End if
			Elseif Fld.Name = "Name" Then
				If arrDecrypt(2) = true then
					Name = DecryptString(oRS("Name"))
				Else
					Name = oRS("Name")
				End if
			Elseif Fld.Name = "Address" Then
				If arrDecrypt(3) = true then
					Address = DecryptString(oRS("Address"))
				Else
					Address = oRS("Address")
				End if
			Elseif Fld.Name = "City" Then
				If arrDecrypt(4) = true then
					City = DecryptString(oRS("City"))
				Else
					City = oRS("City")
				End if
			Elseif Fld.Name = "CC#" Then
				If arrDecrypt(5) = true then
					CCN = DecryptString(oRS("CC#"))
				Else
					CCN = oRS("CC#")
				End if
			Elseif Fld.Name = "ExpDate" Then
				If arrDecrypt(6) = true then
					ExpDate = DecryptString(oRS("ExpDate"))
				Else
					ExpDate = oRS("ExpDate")
				End if
			Elseif Fld.Name = "SSN" Then
				If arrDecrypt(7) = true then
					SSN = DecryptString(oRS("SSN"))
				Else
					SSN = oRS("SSN")
				End if
			Elseif Fld.Name = "BloodType" Then
				If arrDecrypt(8) = true then
					BloodType = DecryptString(oRS("BloodType"))
				Else
					BloodType = oRS("BloodType")
				End if
			End if
		Next
%>
			<tr  bgcolor=#cccccc align=left>
				<td><%=Server.HTMLEncode(PatientID)%>
				<td><%=Server.HTMLEncode(Name)%>
				<td><%=Server.HTMLEncode(Address)%>
				<td><%=Server.HTMLEncode(City)%>
				<td><%=Server.HTMLEncode(CCN)%>
				<td><%=Server.HTMLEncode(ExpDate)%>
				<td><%=Server.HTMLEncode(SSN)%>
				<td><%=Server.HTMLEncode(BloodType)%>
<%
		oRS.MoveNext
	Loop

	Set Flds = Nothing
	Set oRS = Nothing
	Set oConn = Nothing

' This function (simulates) the decryption of a string. This function should
' not be used as a true decryption routine.
Function DecryptString(Value)
	' Create the EncryptedData object.
	Set EncryptedData = CreateObject("CAPICOM.EncryptedData")

	' Set secret.
	EncryptedData.SetSecret Secret
	EncryptedData.Decrypt(Value)
	DecryptString = EncryptedData.Content
End Function
%>
		</table>
	</body>
</html>
